// PG_IconMap.h: interface for the PG_IconMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PG_ICONMAP_H__D59942E1_4760_11D3_89E9_B22D5EEDF261__INCLUDED_)
#define AFX_PG_ICONMAP_H__D59942E1_4760_11D3_89E9_B22D5EEDF261__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Oidtable.h"
#include "ptrlist.h"

class PG_IconMapElement
{
public:
	PG_IconMapElement( PtrList<QOC> &rOCList, int nIconID );
	virtual ~PG_IconMapElement();

public:
	BOOL QueryGetIconID( QOC *pOC, int &rIconID );

private:
	PtrList<QOC> m_OCList;
	int m_nIconID;
};

class PG_IconMap  
{
public:
	PG_IconMap();
	virtual ~PG_IconMap();

public:
	BOOL Load();

public:
	BOOL GetIconID( QOC *pOC, int &rIconID );
	BOOL GetIconID( QEntry *pEntry, int &rIconID );

private:
	PtrList<PG_IconMapElement> m_iconList;
	int m_defaultID;
};

#endif // !defined(AFX_PG_ICONMAP_H__D59942E1_4760_11D3_89E9_B22D5EEDF261__INCLUDED_)
