#if !defined(AFX_PG_LHSTABCTRL_H__279C6722_14FB_11D3_9024_0020AFF7CE08__INCLUDED_)
#define AFX_PG_LHSTABCTRL_H__279C6722_14FB_11D3_9024_0020AFF7CE08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PG_LHSTabCtrl.h : header file
//

#include "PG_TabCtrlBase.h"
#include "PG_FormWin.h"

/////////////////////////////////////////////////////////////////////////////
// PG_LHSTabCtrl window

template PtrList<CWnd>;

class PG_LHSTabCtrl : public PG_TabCtrlBase
{
// Construction
public:
	PG_LHSTabCtrl();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PG_LHSTabCtrl)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~PG_LHSTabCtrl();

public:
	//
	// Create form search input windows
	void CreateTabPages();

	//
	// Select the identified tab page
	void SelectTab( int tab_id, BOOL flash = FALSE );

	//
	// Show the DIT browser
	void ShowDITCtrl();

private:
	//
	// Show or hide a tab window
	void ShowTab( int tab_id, int show_cmd, BOOL flash = FALSE );

private:
	CWnd *GetTabWindow( int tab_id );

private:
	PtrList<PG_FormWin> form_win_list;

	// Generated message map functions
protected:
	//{{AFX_MSG(PG_LHSTabCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSelchange(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PG_LHSTABCTRL_H__279C6722_14FB_11D3_9024_0020AFF7CE08__INCLUDED_)
