// PG_TabCtrlBase.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_TabCtrlBase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PG_TabCtrlBase

PG_TabCtrlBase::PG_TabCtrlBase()
{
	defaultFont = NULL;
  tabNum = 0;
	cur_sel_id = -1;
}

PG_TabCtrlBase::~PG_TabCtrlBase()
{
	;
}


BEGIN_MESSAGE_MAP(PG_TabCtrlBase, CTabCtrl)
	//{{AFX_MSG_MAP(PG_TabCtrlBase)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PG_TabCtrlBase message handlers

void PG_TabCtrlBase::SetDefaultFont()
{
  CFont *font = new CFont;
  CDC *dc = GetDC();
  int fnth = 12; //MulDiv(9, dc->GetDeviceCaps(LOGPIXELSY), 72);

  BOOL font_ok = font->CreateFont
    (-fnth, 0,  // Width and height
     0, 0,      // Escapement and orientation
     0, 0, 0, 0, // Weight, italic, underline, strikeout
     ANSI_CHARSET,
     OUT_DEFAULT_PRECIS,
     CLIP_DEFAULT_PRECIS,
     DEFAULT_QUALITY,
     VARIABLE_PITCH|FF_DONTCARE,
     "Arial");

#ifdef _DEBUG
  if (font_ok == FALSE)
      TRACE( "Failed to set new font in PG_TabCtrlBase::SetDefaultFont().\n" );
#endif 
  
  defaultFont = font;
  SetFont(font);
  ReleaseDC(dc);
}

int PG_TabCtrlBase::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if ( CTabCtrl::OnCreate( lpCreateStruct ) == -1 )
		return -1;
	
	SetDefaultFont();	
	return 0;
}

void PG_TabCtrlBase::PostNcDestroy() 
{
	CTabCtrl::PostNcDestroy();
}

void PG_TabCtrlBase::OnDestroy() 
{
	if (defaultFont != NULL)
		{	
			SetFont( NULL );
			delete defaultFont;
			defaultFont = NULL;
		}

	CTabCtrl::OnDestroy();
}
