// PG_Configuration.h: interface for the PG_Configuration class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PG_CONFIGURATION_H__D59942E0_4760_11D3_89E9_B22D5EEDF261__INCLUDED_)
#define AFX_PG_CONFIGURATION_H__D59942E0_4760_11D3_89E9_B22D5EEDF261__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PG_IconMap.h"
#include "PG_EntryViewConfig.h"

class PG_Configuration  
{
public:
	PG_Configuration();
	virtual ~PG_Configuration();

public:
	BOOL Load();
	BOOL Save();

public:
	PG_IconMap &IconMap()
		{ return m_iconMap; } ;

	PG_EntryViewConfig &EntryViewConfig()
		{ return m_entryViewConfig; } ;

private:
	PG_IconMap m_iconMap;
	PG_EntryViewConfig m_entryViewConfig;
};

#endif // !defined(AFX_PG_CONFIGURATION_H__D59942E0_4760_11D3_89E9_B22D5EEDF261__INCLUDED_)
